#include "chess.h"
#include "data.h"

void cBOARD::setaffected(int pos, int color, int ptype, unsigned int bit){
    int i, dest, dlta;//, dpt;
    switch(ptype){
        case KING:
            i = 0;
            do{
                dest = pos + delta[i];
                if(dest & OFFBOARD);
                else control[dest] |= bit;
                if(i == 7) break;
                i++;
            }while(1);    
        break;
        case QUEEN:
            i = 0;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] |= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if(dpt != BISHOP) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 3) break;
                i++;
            }while(1); 
            i = 4;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] |= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if(dpt != ROOK) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 7) break;
                i++;
            }while(1);
        break;
        case ROOK:
            i = 4;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] |= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if((dpt != QUEEN) &&
                           (dpt != ROOK)) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 7) break;
                i++;
            }while(1);
        break;
        case BISHOP:
            i = 0;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] |= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if((dpt != BISHOP) &&
                           (dpt != QUEEN)) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 3) break;
                i++;
            }while(1);
        break;
        case KNIGHT:
            i = 8;
            do{
                dest = pos + delta[i];
                if(dest & OFFBOARD);
                else control[dest] |= bit;
                if(i == 15) break;
                i++;
            }while(1);
        break;
        case PAWN:
            if(color == WHITE){
                dest = pos - 17;
                if(dest & OFFBOARD);
                else control[dest] |= bit;
                dest = pos - 15;
                if(dest & OFFBOARD);
                else control[dest] |= bit;
            }
            else{
                dest = pos + 17;
                if(dest & OFFBOARD);
                else control[dest] |= bit;
                dest = pos + 15;
                if(dest & OFFBOARD);
                else control[dest] |= bit;
            }
        break;
        case EMPTY: //cout << "setting ctrl of EMPTY!";
        break;
    }
}

void cBOARD::clraffected(int pos, int color, int ptype, unsigned int bit){
    bit = ~bit;
    int i, dest, dlta;//, dpt;
    switch(ptype){
        case KING:
            i = 0;
            do{
                dest = pos + delta[i];
                if(dest & OFFBOARD);
                else control[dest] &= bit;
                if(i == 7) break;
                i++;
            }while(1);    
        break;
        case QUEEN:
            i = 0;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] &= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if(dpt != BISHOP) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 3) break;
                i++;
            }while(1);
            i = 4;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] &= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if(dpt != ROOK) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 7) break;
                i++;
            }while(1); 
        break;
        case ROOK:
            i = 4;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] &= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if((dpt != QUEEN) &&
                           (dpt != ROOK)) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 7) break;
                i++;
            }while(1);
        break;
        case BISHOP:
            i = 0;
            do{
                dlta = delta[i];
                dest = pos + dlta;
                do{
                    if(dest & OFFBOARD) break;
                    control[dest] &= bit;
                    if(square[dest].isoccupied()) break;
                    /*
                    if((dpt = square[dest].ptype) != EMPTY){
                        if(square[dest].color != color) break;
                        if((dpt != BISHOP) &&
                           (dpt != QUEEN)) break;
                    }//*/
                    dest += dlta;
                }while(1);
                if(i == 3) break;
                i++;
            }while(1);
        break;
        case KNIGHT:
            i = 8;
            do{
                dest = pos + delta[i];
                if(dest & OFFBOARD);
                else control[dest] &= bit;
                if(i == 15) break;
                i++;
            }while(1);
        break;
        case PAWN:
            if(color == WHITE){
                dest = pos - 17;
                if(dest & OFFBOARD);
                else control[dest] &= bit;
                dest = pos - 15;
                if(dest & OFFBOARD);
                else control[dest] &= bit;
            }
            else{
                dest = pos + 17;
                if(dest & OFFBOARD);
                else control[dest] &= bit;
                dest = pos + 15;
                if(dest & OFFBOARD);
                else control[dest] &= bit;
            }
        break;
        case EMPTY: //cout << "clearing ctrl of EMPTY!";
        break;
    }
}

//*
void cBOARD::clear_all(unsigned int affected){
    int sq, ptype, pindex, bits;
    unsigned int  lsb;
    
    bits = affected & 0x0000ffff;
    while(bits){
        lsb = bits & -bits; // get lsb
        bits ^= lsb; // reset bit
		// below only works on 16 bits
        /*pindex = ((((((( (lsb & 0xff00) != 0) ) << 1)
        + ( (lsb & 0xf0f0) != 0) ) << 1)
        + ( (lsb & 0xcccc) != 0) ) << 1)
        + ( (lsb & 0xaaaa) != 0) ; */
        pindex = BSR(lsb);
		sq = pieces[WHITE][pindex];
        ptype = square[sq].ptype;
        clraffected(sq, WHITE, ptype, lsb);
    }
    
    bits = affected & 0xffff0000;  //>> 16;
    while(bits){
        lsb = bits & -bits; // get lsb
        bits ^= lsb; // reset bit
        /*pindex = ((((((( (lsb & 0xff00) != 0) ) << 1)
        + ( (lsb & 0xf0f0) != 0) ) << 1)
        + ( (lsb & 0xcccc) != 0) ) << 1)
        + ( (lsb & 0xaaaa) != 0) ;*/ // bit index
        pindex = BSR(lsb);
        sq = pieces[BLACK][pindex-16];
        ptype = square[sq].ptype;
        clraffected(sq, BLACK, ptype, lsb); //  << 16
    }
}
//*/

/*
void cBOARD::clear_all(unsigned int affected){
    int sq, ptype, pindex;
    
    unsigned int lsb, bits;
    bits = affected & 0x0000ffff;
    pindex = 0;
    lsb = 1;
    while(bits){
        if(bits & lsb){
            bits ^= lsb;
            sq = pieces[WHITE][pindex];
            ptype = square[sq].ptype;
            clraffected(sq, WHITE, ptype, lsb);
        }
        pindex++;
        lsb <<= 1;    
    }
    
    bits = affected & 0xffff0000;
    pindex = 0;
    lsb = 0x00010000;
    while(bits){
        if(bits & lsb){
            bits ^= lsb;
            sq = pieces[BLACK][pindex];
            ptype = square[sq].ptype;
            clraffected(sq, BLACK, ptype, lsb);
        }
        pindex++;
        lsb <<= 1;    
    }
}
//*/
//*
void cBOARD::set_all(unsigned int affected){
    int sq, ptype, pindex, bits;
    unsigned int lsb;
    
    bits = affected & 0x0000ffff;
    while(bits){
        lsb = bits & -bits; // get lsb
        bits ^= lsb; // reset bit
        /*pindex = ((((((( (lsb & 0xff00) != 0) ) << 1)
        + ( (lsb & 0xf0f0) != 0) ) << 1)
        + ( (lsb & 0xcccc) != 0) ) << 1)
        + ( (lsb & 0xaaaa) != 0) ;*/ // bit index
        pindex = BSR(lsb);
        sq = pieces[WHITE][pindex];
        ptype = square[sq].ptype;
        setaffected(sq, WHITE, ptype, lsb);
    }
    
    bits = affected & 0xffff0000; //  >> 16;
    while(bits){
        lsb = bits & -bits; // get lsb
        bits ^= lsb; // reset bit
        /*pindex = ((((((( (lsb & 0xff00) != 0) ) << 1)
        + ( (lsb & 0xf0f0) != 0) ) << 1)
        + ( (lsb & 0xcccc) != 0) ) << 1)
        + ( (lsb & 0xaaaa) != 0) ; */// bit index
        pindex = BSR(lsb);
        sq = pieces[BLACK][pindex-16];
        ptype = square[sq].ptype;
        setaffected(sq, BLACK, ptype, lsb);//  << 16
    }
}
//*/
/*
void cBOARD::set_all(unsigned int affected){
    int sq, ptype, pindex;
    
    unsigned int lsb, bits;
    bits = affected & 0x0000ffff;
    pindex = 0;
    lsb = 1;
    while(bits){
        if(bits & lsb){
            bits ^= lsb;
            sq = pieces[WHITE][pindex];
            ptype = square[sq].ptype;
            setaffected(sq, WHITE, ptype, lsb);
        }
        pindex++;
        lsb <<= 1;    
    }
    
    bits = affected & 0xffff0000;
    pindex = 0;
    lsb = 0x00010000;
    while(bits){
        if(bits & lsb){
            bits ^= lsb;
            sq = pieces[BLACK][pindex];
            ptype = square[sq].ptype;
            setaffected(sq, BLACK, ptype, lsb);
        }
        pindex++;
        lsb <<= 1;    
    }
}
//*/

void cBOARD::init_affected(){
    int pos = 0;
    do{
        control[pos] = 0;
    }while(++pos < 128);
    pos = 0;    
    do{
        if(square[pos].pindex>=0 && square[pos].pindex < 16 && square[pos].color>=0 && square[pos].color < 2)
            setaffected(pos, square[pos].color, square[pos].ptype, P2BIT(square[pos].pindex, square[pos].color));
        //cout << pos << ":" << square[pos].pindex << "  ";
        if(pos == 119) break;
        if((pos & 7) == 7) pos += 9;
        else pos++;
    }while(1);
}

/*
    safe mobility && control of space
    tally control of squares and check for trapped
    if a square IS 'attacked by MY piece AND NOT attacked by smaller
    enemy piece OR is attacked by any enemy piece and NOT defended twice
    it is not a safe escape square
//*/
int cBOARD::count_ctrl(){
    int s = 0, i = 0;
    do{
        s += center[i]*((control[i] & mask[xside]) > 0)-((control[i] & mask[side]) > 0);
        if(i == 119) break;
		i++;
		i += (i&8);
    }while(1);
    return s;
}

